<?php

/**
	Determines if the user can comment on a suggestion. A user is not allowed to comment on a
	suggestion if they were the last person to comment and it has been less than 5 hours from when
	they last  commented on this suggestion.
	
	@param int suggestion ID
	
	@return boolean
*/
function userCanSuggest(){
	if($_SESSION['admin']==1)
		return 1;

	$select_statement = "SELECT count(*) as count FROM suggestions WHERE (user_id = '{$_SESSION['user_id']}' AND DATE_SUB(CURDATE(), INTERVAL 6 HOUR) <= suggestions.created_on) ";
	$select_query = mysql_query($select_statement)or die ('Problem verifying user suggest permissions' . mysql_error());
	
	return ( mysql_result($select_query, 0, 'count') == 0 );
}

/**
	Enters a new suggestion into the database and generates
	the appropriate suggestion rank.
	
	@param Array('title' => String,
				'body' => String
				'name' => String
				'category_id' => int
			)
	@return int id of the entered suggestion
*/
function enterSuggestion($suggestionElements){
	if(!userCanSuggest())
		return 0;

	foreach($suggestionElements as $element)
		addslashes($element);
	
	$insert_statement = "INSERT INTO suggestions (user_id, title, body, created_on, user_name, category_id) VALUES ('{$_SESSION['user_id']}', '{$suggestionElements['title']}', '{$suggestionElements['body']}', NOW(), '{$suggestionElements['name']}', {$suggestionElements['category_id']} )";
	$insert_query = mysql_query($insert_statement) or die("Error entering the suggestion<br />\r\n" . mysql_error());
	
	
	$insertId = mysql_insert_id();
	addVote(Array('user_id'=>$_SESSION['user_id'], 'suggestion_id'=>$insertId, 'rating'=>0));
	
	return $insertId;
	
	/*
		User mysql_insert_id() to automatically set the median rank
		for the new suggestion.	
				
		SELECT x.val from data x, data y
		GROUP BY x.val
		HAVING SUM(SIGN(1-SIGN(y.val-x.val))) = (COUNT(*)
		+1)/2
	*/
}


/**
	Deletes the suggestion and all associated votes.
	
	@param int suggestion ID
*/
function removeSuggestion($suggestionId){
	//Lock the tables just to be safe
	mysql_query("LOCK TABLES suggestions WRITE, votes WRITE");
	
	$delete_statement = "DELETE FROM suggestions WHERE id={$suggestionId} LIMIT 1";
	mysql_query($delete_statement) or die ( 'Probelm removing suggestion. ' . mysql_error());
	
	mysql_query("UNLOCK TABLES");
}


/**
	Returns an ordered list of the suggesions. The suggesions
	ar limited by pagination. The desired page number and amount of
	suggestions per page are required parameter.
	
	See http://www.allsyntax.com/tutorials/PHP/23/Pagination-with-PHP/2.php
	for how the pagination will work.
	
	@params
		$page is the desired page number,
		$limit is the number of elements per page,
		$categoryId is optional and it will return suggestions limited ot the specified ID
		
	@return Array
		Returns an ordered array of arrays containing data for each
		suggesion. The array contents are limited by pagination.
		
		Array(
				.....
				Array('id'=>int, 'name'=>String,'title'=>String, 'body'=>string, 'rating' => int, 'created_on' => DATETIME, 'category_id'=>int, 'list_position'=>int)
				.....
			)
*/
function getSuggestionList($page, $limit, $categoryId=0){
	if($page<0 || $page>totalPages($limit, $categoryId))
		return 0;

	/*
		This one select statement is the culmination of a nights worth
		of researching and learning MySQL.
		
		The statement retrives the suggestions ordered by their rank
		as specified by the tally of all their votes, and limits 
		the list to the desired page and page size.
	*/
	$offset = $page*$limit;
	$select_statement = "SELECT suggestions.*, SUM(votes.rating) as rank, suggestions.created_on FROM suggestions INNER JOIN votes ON (suggestions.id=votes.suggestion_id" . (($categoryId != 0 ) ? " AND suggestions.category_id = {$categoryId}" : "") . ") GROUP BY suggestions.id ORDER BY rank DESC, suggestions.created_on DESC LIMIT {$offset}, {$limit}";
	
	$select_query = mysql_query($select_statement) or die( ' Problem getting the suggestions list ' . mysql_error());
	
	return generateSuggestionsArray($select_query);
}


/**
	A variation of getSuggestionList().
	
	The suggestions are order by their created_on date and not by their rank. 
*/
function getNewestSuggestionList($page, $limit, $categoryId=0){
	if($page<0 || $page>totalPagesOfNewest($limit, $categoryId))
		return 0;
		
	$offset = $page*$limit;
	
	if(0)$select_statement = "SELECT suggestions.*, SUM(rating) as rank, suggestions.created_on FROM suggestions INNER JOIN votes ON (suggestions.id=votes.suggestion_id AND DATE_SUB(CURDATE(), INTERVAL 7 DAY) <= suggestions.created_on" . (($categoryId != 0 ) ? " AND suggestions.category_id = {$categoryId}" : "") . ") GROUP By suggestions.id ORDER BY rank  DESC, suggestions.created_on LIMIT {$offset}, {$limit}";
	else $select_statement = "SELECT suggestions.*, SUM(rating) as rank, suggestions.created_on FROM suggestions INNER JOIN votes ON (suggestions.id=votes.suggestion_id " . (($categoryId != 0 ) ? " AND suggestions.category_id = {$categoryId}" : "") . ") GROUP By suggestions.id ORDER BY suggestions.created_on DESC LIMIT {$offset}, {$limit}";
	
	$select_query = mysql_query($select_statement) or die('Problem getting newest suggestions list' . mysql_error());
	$nSuggestions = mysql_numrows($select_query);
	
	return generateSuggestionsArray($select_query);
}

/**
	Returns the number of pages. Use this for building the next page,
	previous page and intermediate page links. 
	
	@param int Number of suggestions per page
	@param int Optional paramameter that indicates the number of pages for the specified category. 
	
	@return int
*/
function totalPages($limit, $categoryId=0){
	$select_statement = ($categoryId == 0)
	?	"SELECT count(*) as count FROM suggestions"
	:	"SELECT count(*) as count FROM suggestions WHERE suggestions.category_id={$categoryId}";
		
	$select_query = mysql_query($select_statement);
	return ceil(mysql_result($select_query, 0, 'count') / $limit);
}

/**
	Similar to totalPages excpet that it counts the number of pages for articles returned by getNewestSuggestions..
*/
function totalPagesOfNewest($limit, $categoryId=0){

	return totalPages($limit, $categoryId);
	
	$select_statement = ($categoryId == 0)
	?	"SELECT count(*) as count FROM suggestions WHERE DATE_SUB(CURDATE(), INTERVAL 7 DAY) <= suggestions.created_on"
	:	"SELECT count(*) as count FROM suggestions WHERE (DATE_SUB(CURDATE(), INTERVAL 7 DAY) <= suggestions.created_on AND suggestions.category_id={$categoryId})";
	
	
	$select_query = mysql_query($select_statement) or die ('Prblem summing the pages of newest' . mysql_eror() );
	return ceil(mysql_result($select_query, 0, 'count') / $limit);
}

/**
	Retrievs the data for a single suggesiont specified by $suggestionId
	
	@param int suggestion ID
	
	@return
		Array(	...Suggestion Data...	)
*/
function getSuggestion($suggestionId){
	$suggestion = Array();
	
	$select_statement = "SELECT suggestions.*, SUM(votes.rating) as rank FROM suggestions INNER JOIN votes ON (id={$suggestionId} AND suggestions.id=votes.suggestion_id) GROUP BY suggestions.id";
	$select_query = mysql_query($select_statement) or die ('Failed to get suggesion (id=' . $suggestionId . ') ' . mysql_error());

	$outerArray = generateSuggestionsArray($select_query);
	return $outerArray[0];
}

/**
	Calcuates and returns the aggregate rating specified by
	the suggestion ID.
	
	@param int suggestion ID
*/
function getSuggestionRating($suggestionId){
	$select_statement = "SELECT SUM(rating) as rating FROM suggestions INNER JOIN votes ON (id={$suggestionId} AND suggestions.id=votes.suggestion_id) GROUP BY suggestions.id";
	$select_query = mysql_query($select_statement) or die ('Failed to get suggesion  rating(id=' . $suggestionId . ') ' . mysql_error());	

	return mysql_result($select_query, 0, 'rating');
}

/**
	Allows the user who created a suggestion to make edits. Old
	suggesion data will be overriden.
	
	@param int suggestion ID	
	@param	Array, suggestion data in the following form:
		Array( 	'id' => int
				'title' => String,
				'body' => String,
				'name' => String				
			 )
*/
function editSuggestion($suggestionData){

	foreach($suggestionData as $element)
		addslashes($element);

	//Lock the tables just to be safe	
	mysql_query("LOCK TABLES suggestions WRITE");
	
	$update_statement = "UPDATE suggestions SET title='{$suggestionData['title']}', body='{$suggestionData['body']}', user_name='{$suggestionData['name']}' WHERE id={$suggestionData['id']}";
	$update_query = mysql_query($update_statement) or die ('Failed to update suggesion (id=' . $suggestionId . ') ' .mysql_error());
	
	mysql_query("UNLOCK TABLES");

}

/**
	Determines if the user (identified by sessions) is given authority
	to edit the	suggestion.
	
	@param int suggestion ID
	@return boolean
*/
function userCanEdit($suggestionId){
	$select_statement = "SELECT user_id FROM suggestions WHERE suggestions.id={$suggestionId}";	
	$select_query = mysql_query($select_statement) or die('Problem checking the user\'s edit permissions<br />' . mysql_error());
	$suggestion_user_id = mysql_result($select_query, 0, 'user_id');

	return ($suggestion_user_id == $_SESSION['user_id']);
}

/**
	Helper function that generates the suggestions list array.
	@ param mysql_result
	
	@return Array( ..Array() ..)
*/
function generateSuggestionsArray($select_query){

	$nSuggestions = mysql_numrows($select_query);
	
	$suggestionList = Array();
	$suggestion = Array('id'=>-1, 'title'=>'', 'body'=>'');
	for($n=0; $n < $nSuggestions; $n++){
		
		$suggestion['id'] = mysql_result($select_query, $n, 'id');
		$suggestion['name'] = mysql_result($select_query, $n, 'user_name');
		$suggestion['title'] = mysql_result($select_query, $n, 'title');
		$suggestion['body'] = mysql_result($select_query, $n, 'body');
		$suggestion['rating'] = mysql_result($select_query, $n, 'rank');
		$suggestion['created_on'] = mysql_result($select_query, $n, 'created_on');
		$suggestion['category'] = mysql_result($select_query, $n, 'category_id');
		// add the list position info to all the array elements
		$suggestion['list_position'] = $n;
		
		$suggestionList[] = $suggestion;
	}
	return $suggestionList;	
}
?>