<?php

require_once('db_functions.php');

//	Reformats the DATETIME from mysql, 2006-08-19 13:53:38, to ten till 19 Aug, 2006
function formatDate($date){
	$months = array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sept', 'Oct', 'Nov', 'Dec');
	$year = intval(substr($date,0,4));
	$month = intval(substr($date,5,2));
	$month = $months[intval($month)-1];
	$day = intval(substr($date,8,2));
	
	return $month.' '.$day.', '.$year;
}


//	Reformats the DATETIME from mysql, 2006-08-19 13:53:38, to a fuzzy clock
function formatTime($date){
	$cHour = intval(substr($date,11,2))%12;
	$nHour = ($cHour + 1)%12;
	$minute = intval(substr($date,14,2));
	$hourNames = array('Twelve', 'One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight', 'Nine', 'Ten', 'Eleven');
	// $cHour is the current hour;
	// $nHour is the next hour
	$fuzzy = array(
					$hourNames[$cHour].' o\'clock',
					'five past '.$hourNames[$cHour],
					'ten past '.$hourNames[$cHour],
					'quarter past '.$hourNames[$cHour],
					'twenty past '.$hourNames[$cHour],
					'twenty five past '.$hourNames[$cHour],
					'half past '.$hourNames[$cHour],
					'twenty five to '.$hourNames[$nHour],
					'twenty to '.$hourNames[$nHour],
					'quarter to '.$hourNames[$nHour],
					'ten to '.$hourNames[$nHour],
					'five to '.$hourNames[$nHour],
					$hourNames[$nHour].' o\'clock'
				);		
	return $fuzzy[floor($minute/5)];
}


?>