<?php
/* includes */

	require_once('../../db_functions.php');
	require_once('../../page_functions.php');
	require_once('../../sanitize.php');

/* session_start() and definitions */

	$categories = array(
		'top',
		'hardware',
		'software',
		'accessories',
		'store',
		'bugs'
	);
	
/* processing the web address with page and category */
/* defaulting to the first page of new suggestions */

	$_SESSION['suggestion_id'] = $suggestion_id = sanitize_int($_GET['suggestion_id']);
	if($suggestion_id <= 0){
		header('Location: ../');
	}
	
/* processing all actions that can happen within a page */
/* by rank of most used:

	Post a Comment
		Process an Edited Comment
	Remove a Comment
	Edit a Comment	
*/

	foreach($_POST as $key => $value){
		if(($_POST['name'] || $_SESSION['name']) && $_POST['body']){
			$commentData['suggestion_id'] = $suggestion_id;
			if($_SESSION['name']){
				$commentData['name'] = $_SESSION['name'];
			}
			else{
				$_SESSION['name'] = $commentData['name'] = sanitize_html_string($_POST['name']);
			}
			$commentData['body'] = sanitize_html_string($_POST['body']);
			postComment($commentData);
			break;
		}
		else if($value == "+"){
			bumpSuggestion(sanitize_int($key),1);
		}
		else if($value == "-"){
			bumpSuggestion(sanitize_int($key),-1);
		}
		else if($value == "rm_c"){
			deleteComment(sanitize_int($key));
		}
		else if($value == "rm_s"){
			removeSuggestion(sanitize_int($key));
		}
		else if($value == "edit_s"){
			$_SESSION['edit'] = 1;
			$_SESSION['suggestion_id'] = $key;
			header('Location: ../submit_a_suggestion/');
		}
	}
	
/* load suggestions and comments */
	$suggestion =  getSuggestion($suggestion_id);
	$commentList = getCommentList($suggestion_id);
	
/* figure out where that suggestion is so they can return */
	$suggestion_page = floor($suggestion['list_position']/10);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">
<html>
	<head>
		<title>comments - Apples (unofficial) to do list.</title>
		<link href="../main_style.css" rel="stylesheet" type="text/css"/>
		<link rel="alternate" type="application/rss+xml" title="RSS" href="feed.php?suggestion_id=<?=$suggestion_id?>"/>
		<meta name="description" content="Suggestions for Apple Computer"/>
		<meta name="keywords" content="Apple Computer, MacBook, MacBook Pro, iMac, Mac mini, Mac Pro, iPod, iPod nano, iPod shuffle, OS X, iLife, iPhoto, iWeb, iMovie HD, iDVD, GarageBand"/>
	</head>
	<body>
	<div id="contain_everything">
		<div id="left_content">
			<div align="center">
				<a href="../?page=0&amp;category=<?php echo $categories[0]; ?>"/>
					<img alt="ATDL" src="../images/ATDL.gif" border="0"/>
				</a>
			</div>
			<div align="center">
				<ul id="top_nav"><?php 
				for($i=1;$i<6;$i++){
					echo '<li>';
					echo '<a href="../?page=0&amp;category='.$categories[$i].'"/>';
					echo '<img alt="'.$categories[$i].'" src="../images/'.$categories[$i].'.gif" hspace="15" border="0"/>';
					echo '</a>';
					echo '</li>';
				} 
				?></ul>
			</div>
			<div>
				
			</div>
			<form action="?suggestion_id=<?=$suggestion_id?>" method="POST">
				<div class="rbroundbox_s">
					<div class="rbtop_s"><div></div></div>
						<div class="rbcontent_s">
							<div class="suggestion">
								<h1 class="title">
									<a href="comments/?suggestion_id=<?=$suggestion['id']?>">
										<?=reverse_sanitize_html_string($suggestion['title'])?>
									</a>
								</h1>
								<div class="rating">
									<input class="vote" type="submit" value="+" name="<?=$suggestion['id']?>"/>
									<?=$suggestion['rating']?>
									<input class="vote" type="submit" value="-" name="<?=$suggestion['id']?>"/>
								</div>
								<div class="body">
									<?=reverse_sanitize_html_string($suggestion['body'])?>
								</div>
								<div align="center" class="admin"><?php if($_SESSION['admin']==1){
									echo '<input type="submit" value="rm" name="'.$suggestion['id'].'"/>';
									echo '<input type="submit" value="edit" name="'.$suggestion['id'].'"/>';
								}?></div>
								<span class="name_date">
									<?=reverse_sanitize_html_string($suggestion['name']).' - '?>
									<?='['.formatDate($suggestion['created_on']).']'?>
								</span>
							</div><!-- /suggestion -->
						</div><!-- /rbcontent_s -->
					<div class="rbbot_s"><div></div></div>
				</div><!-- /rbroundbox_s -->
				<?php foreach($commentList as $key => $comment){ ?>
					<div class="rbroundbox_c">
						<div class="rbtop_c"><div></div></div>
							<div class="rbcontent_c">
								<div class="comment">
									<div class="top">
										<span class="name"><?=reverse_sanitize_html_string($comment['name'])?> -</span>
									</div>
									<div class="bottom">
										<div class="body"><?=reverse_sanitize_html_string($comment['body'])?></div>
										<div class="time"><?='['.formatTime($comment['created_on']).']'?></div>
										<?php	
											if($_SESSION['admin']==1){ echo '<input type="submit" value="rm_c" name="'.$comment['id'].'"/>';}
										?>
									</div>
								</div><!-- /comment -->
							</div><!-- /rbcontent -->
						<div class="rbbot_c"><div></div></div>
					</div><!-- /rbroundbox -->
				<?php } ?>
				<div align="center" id="submit_comment">
					<div class="row">
						<div class="label">
							<label for="name">name</label>
						</div>
						<div class="form">
							<input name="name" id="name" type="text" tabindex="1" size="25" maxlength="25" value="<?php if($_SESSION['name']){echo $_SESSION['name'];} ?>"/>
						</div>
					</div>
					<div class="row">
						<div class="label">
							<label for="body">comment</label>
						</div>
						<div class="form">
							<textarea name="body" id="body" tabindex="2" cols="70" rows="5"></textarea>
						</div>
					</div>
					<div class="button"><input type="submit" value="Submit"/></div>
				</div>
			</form>
		</div>
		<div align="left" id="right_content">
			<ul id="side_nav">
				<li>
					<a href="../about/"/>
						<img alt="about" src="../images/about.gif" border="0"/>
					</a>
				</li>
				<li>
					<a href="../faq/"/>
						<img alt="faq" src="../images/faq.gif" border="0"/>
					</a>
				</li>
				<li>
					<a href="../contact_us/"/>
						<img alt="contact_us" src="../images/contact_us.gif" border="0"/>
					</a>
				</li>
			</ul>
			<script type="text/javascript">
				<!--
				google_ad_client = "pub-2143554141151654";
				google_alternate_color = "FFFFFF";
				google_ad_width = 120;
				google_ad_height = 600;
				google_ad_format = "120x600_as";
				google_ad_type = "text_image";
				google_ad_channel ="";
				google_color_border = "999999";
				google_color_bg = "CCCCCC";
				google_color_link = "000000";
				google_color_text = "333333";
				google_color_url = "666666";
				//-->
			</script>
			<script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
			</script>
		</div>
	</div>
	<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
	</script>
		<script type="text/javascript">
		_uacct = "UA-753510-1";
		urchinTracker();
	</script>
	</body>
</html>
<?php
mysql_close();
?>