<?php

/* includes */

	require_once('../db_functions.php');
	require_once('../page_functions.php');
	require_once('../sanitize.php');

/* definitions */

	$SuggestionsPerPage = 10;

	$categories = array(
		'top',
		'hardware',
		'software',
		'accessories',
		'store',
		'bugs'
	);
	
/* processing the web address with page and category */
/* defaulting to the first page of new suggestions */

	$page = sanitize_int($_GET['page']);
	if($page<0 || !$page){$page = 0;}
	
/* wtf why can't i get this same functionality out of a for loop */
	$category = $_GET['category'];
	if($category == 'top'){ $category = 0;}
	else if($category == 'hardware'){ $category = 1;}
	else if($category == 'software'){ $category = 2;}
	else if($category == 'accessories'){ $category = 3;}
	else if($category == 'store'){ $category = 4;}
	else if($category == 'bugs'){ $category = 5;}
	else{ $category = 0;}
	
/* processing all actions that can happen within a page */
/* by rank of most used:

	BumpUP
	BumpDown
	Post a Suggestion
		Process an Edited Suggestion
	Remove a Suggestion
	Edit a Suggestion
	
*/
	foreach($_POST as $key => $value){
		if($value == "+"){
			bumpSuggestion(sanitize_int($key),1);
		}
		else if($value == "-"){
			bumpSuggestion(sanitize_int($key),-1);
		}
		else if(($_POST['name'] || $_SESSION['name']) && $_POST['title'] && $_POST['body']){
			$postSuggestion['category_id'] = sanitize_int($_POST['category_id']);
			$postSuggestion['title'] = sanitize_html_string($_POST['title']);
			$postSuggestion['body'] = sanitize_html_string($_POST['body']);
			if(!$_SESSION['edit']){
				if($_SESSION['name']){$postSuggestion['name'] = $_SESSION['name'];}
				else{$_SESSION['name'] = $postSuggestion['name'] = sanitize_html_string($_POST['name']);}
				enterSuggestion($postSuggestion);
			}
			else{
			 	$postSuggestion['id'] = $_SESSION['suggestion_id'];
				$postSuggestion['name'] = sanitize_html_string($_POST['name']);
				editSuggestion($postSuggestion);
				$_SESSION['edit'] = 0;
				$_SESSION['suggestionID'] = 0;
			}
			break;
		}
		else if($value == "rm"){
			removeSuggestion(sanitize_int($key));
		}
		else if($value == "edit"){
			$_SESSION['edit'] = 1;
			$_SESSION['suggestion_id'] = $key;
			header('Location: submit_a_suggestion/');
		}
	}
	
/* load proper suggestions from the proper category  */

	if($category == 0){
		for($i=1;$i<6;$i++){
			${$categories[$i].'List'} = getSuggestionList(0, 2, $i);
		}
	}
	else{
		$suggestionList = getSuggestionList($page, $SuggestionsPerPage, $category);
		$total_pages = totalPages($SuggestionsPerPage, $category);
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">
<html>
	<head>
		<title><?php echo $categories[$category] ?> suggestions - Apples (unofficial) to do list.</title>
		<link href="main_style.css" rel="stylesheet" type="text/css"/>
		<link rel="alternate" type="application/rss+xml" title="RSS" href="feed.php?page=<?=$page?>&amp;category=<?=$categories[$category]?>"/>
		<meta name="description" content="Suggestions for Apple Computer"/>
		<meta name="keywords" content="Apple Computer, MacBook, MacBook Pro, iMac, Mac mini, Mac Pro, iPod, iPod nano, iPod shuffle, OS X, iLife, iPhoto, iWeb, iMovie HD, iDVD, GarageBand"/>
	</head>
	<body>
	<div id="contain_everything">
		<div id="left_content">
			<div align="center">
				<a href="?page=0&amp;category=<?=$categories[0]?>">
					<img alt="ATDL" src="images/ATDL.gif" border="0"/>
				</a>
			</div>
			
<?php if($category==0){ 
		for($i=1;$i<6;$i++){
?>
			
			<a href="?page=0&amp;category=<?=$categories[$i]?>">
				<img alt="<?=$categories[$i]?>" src="images/<?=$categories[$i]?>.gif" hspace="10" vspace="0" border="0"/>
			</a>
			
			<span class="view">
				<a href="?page=0&amp;category=<?=$categories[$i]?>">
					<img src="images/view.gif" alt="view" />
				</a>
			</span>

			<span class="post">
				<a href="submit_a_suggestion/?category=<?=$categories[$i]?>">
					<img src="images/post.gif" alt="post" />
				</a>
			</span>
			
			<form action="?page=<?=$page?>&amp;category=<?=$categories[$category]?>" method="POST"><?php
			foreach(${$categories[$i].'List'} as $key => $suggestion){
				$suggestion_id = $suggestion['id'];
			?>
			
			<div class="rbroundbox_s">
				<div class="rbtop_s"><div></div></div>
					<div class="rbcontent_s">
						<div class="suggestion">
							<h1 class="title">
								<a href="comments/?suggestion_id=<?=$suggestion['id']?>">
									<?=reverse_sanitize_html_string($suggestion['title'])?>
								</a>
							</h1>
							<div align="center" class="admin"><?php if($_SESSION['admin']==1){
								echo '<input type="submit" value="rm" name="'.$suggestion['id'].'"/>';
								echo '<input type="submit" value="edit" name="'.$suggestion['id'].'"/>';
							}?></div>
							<div class="body">
								<?=reverse_sanitize_html_string($suggestion['body'])?>
							</div>
							<span class="name_date">
								<?='['.formatDate($suggestion['created_on']).']'?>
							</span>
						</div><!-- /suggestion -->
					</div><!-- /rbcontent_s -->
				<div class="rbbot_s"><div></div></div>
			</div><!-- /rbroundbox_s -->
			
			<?php } ?></form>
<?php
		}
	}
	else{
?>
			
			<div align="center">
				<ul id="top_nav"><?php 
				for($i=1;$i<6;$i++){
					echo '<li>';
					echo '<a href="?page=0&amp;category='.$categories[$i].'">';
					echo '<img alt="'.$categories[$i].'" src="images/'.$categories[$i].'.gif" hspace="15" vspace="0" border="0"/>';
					echo '</a>';
					echo '</li>';
				} 
				?></ul>
			</div>
			
			<form action="?page=<?=$page?>&amp;category=<?=$categories[$category]?>" method="POST"><?php
			foreach($suggestionList as $key => $suggestion){
				$suggestion_id = $suggestion['id'];
			?>
			
			<div class="rbroundbox_s">
				<div class="rbtop_s"><div></div></div>
					<div class="rbcontent_s">
						<div class="suggestion">
							<h1 class="title">
								<a href="comments/?suggestion_id=<?=$suggestion['id']?>">
									<?=reverse_sanitize_html_string($suggestion['title'])?>
								</a>
							</h1>
							<div class="rating">
								<input class="vote" type="submit" value="+" name="<?=$suggestion['id']?>"/>
								<?=$suggestion['rating']?>
								<input class="vote" type="submit" value="-" name="<?=$suggestion['id']?>"/>
							</div>
							<div class="body">
								<?=reverse_sanitize_html_string($suggestion['body'])?>
							</div>
							<div align="center" class="admin"><?php if($_SESSION['admin']==1){
								echo '<input type="submit" value="rm" name="'.$suggestion['id'].'"/>';
								echo '<input type="submit" value="edit" name="'.$suggestion['id'].'"/>';
							}?></div>
							<span class="name_date">
								<?='['.formatDate($suggestion['created_on']).']'?>
							</span>
						</div><!-- /suggestion -->
					</div><!-- /rbcontent_s -->
				<div class="rbbot_s"><div></div></div>
			</div><!-- /rbroundbox_s -->
			
			<?php } ?></form>
			
			<div align="right" class="pages"><?php
				for($i=$page-3;$i<($total_pages) && $i<($pages+4);$i++){
					if($i>=0){
						if($i==0){
							if($page==0){echo 'Main Page ';}
							else{echo '<a class="pages" href="index.php?page=0&amp;category='.$categories[$category].'">Main Page</a>';}
						}
						else{
							if($page==$i){echo $i.' ';}
							else{echo '<a class="pages" href="index.php?page='.$i.'&amp;category='.$categories[$category].'">'.($i).'</a> ';}
						}
					}
				} 
			?></div>
			
			<div align="center">
				<a href="submit_a_suggestion/?category=<?=$categories[$category]?>"><img alt="submit" src="images/submit_a_suggestion.gif" border="0"/></a>
			</div>
			
<?php
	}
?>

		</div>
		<div id="right_content">
			<ul id="side_nav">
				<li>
					<a href="about/">
						<img alt="about" src="images/about.gif" border="0"/>
					</a>
				</li>
				<li>
					<a href="faq/">
						<img alt="faq" src="images/faq.gif" border="0"/>
					</a>
				</li>
				<li>
					<a href="contact_us/">
						<img alt="contact_us" src="images/contact_us.gif" border="0"/>
					</a>
				</li>
			</ul>
			<script type="text/javascript">
				<!--
				google_ad_client = "pub-2143554141151654";
				google_alternate_color = "FFFFFF";
				google_ad_width = 120;
				google_ad_height = 600;
				google_ad_format = "120x600_as";
				google_ad_type = "text_image";
				google_ad_channel ="";
				google_color_border = "999999";
				google_color_bg = "CCCCCC";
				google_color_link = "000000";
				google_color_text = "333333";
				google_color_url = "666666";
				//-->
			</script>
			<script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
			</script>
		</div>
	</div>
	<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
	</script>
		<script type="text/javascript">
		_uacct = "UA-753510-1";
		urchinTracker();
	</script>
	</body>
</html>
<?php
mysql_close();
?>